/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     itemis - Initial API and implementation
 * 
 * </copyright>
 */
package org.eclipse.sphinx.examples.hummingbird20.workflows;

import com.google.common.base.Objects;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.mwe.core.WorkflowContext;
import org.eclipse.emf.mwe.core.issues.Issues;
import org.eclipse.emf.mwe.core.monitor.ProgressMonitor;
import org.eclipse.sphinx.emf.mwe.dynamic.AbstractWorkspaceWorkflowComponent;
import org.eclipse.sphinx.emf.mwe.dynamic.IWorkflowSlots;
import org.eclipse.sphinx.examples.hummingbird20.common.Identifiable;
import org.eclipse.xtext.xbase.lib.InputOutput;

@SuppressWarnings("all")
public class HelloHummingbird20WorkflowComponent extends AbstractWorkspaceWorkflowComponent {
  protected void invokeInternal(final WorkflowContext ctx, final ProgressMonitor monitor, final Issues issues) {
    InputOutput.<String>println("Executing Hello Hummingbird 2.0 workflow component");
    final Object model = ctx.get(IWorkflowSlots.MODEL_SLOT_NAME);
    String msg = "Model slot contains : ";
    if ((model instanceof Identifiable)) {
      String _msg = msg;
      String _xifexpression = null;
      boolean _and = false;
      String _name = ((Identifiable)model).getName();
      boolean _notEquals = (!Objects.equal(_name, null));
      if (!_notEquals) {
        _and = false;
      } else {
        String _name_1 = ((Identifiable)model).getName();
        int _length = _name_1.length();
        boolean _greaterThan = (_length > 0);
        _and = _greaterThan;
      }
      if (_and) {
        _xifexpression = ((Identifiable)model).getName();
      } else {
        EClass _eClass = ((Identifiable)model).eClass();
        String _name_2 = _eClass.getName();
        String _plus = ("Error: \'" + _name_2);
        _xifexpression = (_plus + 
          "\' has no name!");
      }
      msg = (_msg + _xifexpression);
    } else {
      String _msg_1 = msg;
      String _string = model.toString();
      msg = (_msg_1 + _string);
    }
    InputOutput.<String>println(msg);
  }
}
